Package org.eclipse.jgit.internal.storage.pack

## Class CachedPack

- java.lang.Object
- - org.eclipse.jgit.internal.storage.pack.CachedPack

Direct Known Subclasses:
  `DfsCachedPack`

    public abstract class CachedPack
    extends Object

Describes a pack file `ObjectReuseAsIs` can append onto a stream.

### Constructor Summary

Constructors
`CachedPack()`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`long` `getDeltaCount()` Get the number of delta objects stored in this pack.
`abstract long` `getObjectCount()` Get the number of objects in this pack.
`abstract boolean` `hasObject​(ObjectToPack obj, StoredObjectRepresentation rep)` Determine if this pack contains the object representation given.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### CachedPack

    public CachedPack()

### Method Detail

#### getObjectCount

    public abstract long getObjectCount()
                                 throws IOException

Get the number of objects in this pack.

Returns:
  the total object count for the pack.
Throws:
  `IOException` - if the object count cannot be read.

#### getDeltaCount

    public long getDeltaCount()
                       throws IOException

Get the number of delta objects stored in this pack.

This is an optional method, not every cached pack storage system knows the precise number of deltas stored within the pack. This number must be smaller than `getObjectCount()` as deltas are not supposed to span across pack files.

This method must be fast, if the only way to determine delta counts is to scan the pack file's contents one object at a time, implementors should return 0 and avoid the high cost of the scan.

Returns:
  the number of deltas; 0 if the number is not known or there are no deltas.
Throws:
  `IOException` - if the delta count cannot be read.

#### hasObject

    public abstract boolean hasObject​(ObjectToPack obj,
                                      StoredObjectRepresentation rep)

Determine if this pack contains the object representation given.

PackWriter uses this method during the finding sources phase to prune away any objects from the leading thin-pack that already appear within this pack and should not be sent twice.

Implementors are strongly encouraged to rely on looking at `rep` only and using its internal state to decide if this object is within this pack. Implementors should ensure a representation from this cached pack is tested as part of `ObjectReuseAsIs.selectObjectRepresentation(PackWriter, org.eclipse.jgit.lib.ProgressMonitor, Iterable)` , ensuring this method would eventually return true if the object would be included by this cached pack.

Parameters:
  `obj` - the object being packed. Can be used as an ObjectId.
  `rep` - representation from the `ObjectReuseAsIs` instance that originally supplied this CachedPack.
Returns:
  true if this pack contains this object.